
// -*- C++ -*-
// $Id: Circular_Dependency_export.h 93878 2011-04-12 12:25:16Z johnnyw $
// Definition for Win32 Export directives.
// ------------------------------
#ifndef CIRCULARDEPENDENCY_EXPORT_H
#define CIRCULARDEPENDENCY_EXPORT_H

#include "ace/config-all.h"

#if defined (ACE_AS_STATIC_LIBS) && !defined (CIRCULARDEPENDENCY_HAS_DLL)
#  define CIRCULARDEPENDENCY_HAS_DLL 0
#endif /* ACE_AS_STATIC_LIBS && CIRCULARDEPENDENCY_HAS_DLL */

#if !defined (CIRCULARDEPENDENCY_HAS_DLL)
#  define CIRCULARDEPENDENCY_HAS_DLL 1
#endif /* ! CIRCULARDEPENDENCY_HAS_DLL */

#if defined (CIRCULARDEPENDENCY_HAS_DLL) && (CIRCULARDEPENDENCY_HAS_DLL == 1)
#  if defined (CIRCULARDEPENDENCY_BUILD_DLL)
#    define CircularDependency_Export ACE_Proper_Export_Flag
#    define CIRCULARDEPENDENCY_SINGLETON_DECLARATION(T) ACE_EXPORT_SINGLETON_DECLARATION (T)
#    define CIRCULARDEPENDENCY_SINGLETON_DECLARE(SINGLETON_TYPE, CLASS, LOCK) ACE_EXPORT_SINGLETON_DECLARE(SINGLETON_TYPE, CLASS, LOCK)
#  else /* CIRCULARDEPENDENCY_BUILD_DLL */
#    define CircularDependency_Export ACE_Proper_Import_Flag
#    define CIRCULARDEPENDENCY_SINGLETON_DECLARATION(T) ACE_IMPORT_SINGLETON_DECLARATION (T)
#    define CIRCULARDEPENDENCY_SINGLETON_DECLARE(SINGLETON_TYPE, CLASS, LOCK) ACE_IMPORT_SINGLETON_DECLARE(SINGLETON_TYPE, CLASS, LOCK)
#  endif /* CIRCULARDEPENDENCY_BUILD_DLL */
#else /* CIRCULARDEPENDENCY_HAS_DLL == 1 */
#  define CircularDependency_Export
#  define CIRCULARDEPENDENCY_SINGLETON_DECLARATION(T)
#  define CIRCULARDEPENDENCY_SINGLETON_DECLARE(SINGLETON_TYPE, CLASS, LOCK)
#endif /* CIRCULARDEPENDENCY_HAS_DLL == 1 */

// Set CIRCULARDEPENDENCY_NTRACE = 0 to turn on library specific tracing even if
// tracing is turned off for ACE.
#if !defined (CIRCULARDEPENDENCY_NTRACE)
#  if (ACE_NTRACE == 1)
#    define CIRCULARDEPENDENCY_NTRACE 1
#  else /* (ACE_NTRACE == 1) */
#    define CIRCULARDEPENDENCY_NTRACE 0
#  endif /* (ACE_NTRACE == 1) */
#endif /* !CIRCULARDEPENDENCY_NTRACE */

#if (CIRCULARDEPENDENCY_NTRACE == 1)
#  define CIRCULARDEPENDENCY_TRACE(X)
#else /* (CIRCULARDEPENDENCY_NTRACE == 1) */
#  if !defined (ACE_HAS_TRACE)
#    define ACE_HAS_TRACE
#  endif /* ACE_HAS_TRACE */
#  define CIRCULARDEPENDENCY_TRACE(X) ACE_TRACE_IMPL(X)
#  include "ace/Trace.h"
#endif /* (CIRCULARDEPENDENCY_NTRACE == 1) */

#endif /* CIRCULARDEPENDENCY_EXPORT_H */
