// -*- C++ -*-
// $Id: Installation_Repository_Manager_export.h 92045 2010-09-27 10:38:22Z johnnyw $
// Definition for Win32 Export directives.
// ------------------------------
#ifndef INSTALLATION_REPOSITORY_MANAGER_EXPORT_H
#define INSTALLATION_REPOSITORY_MANAGER_EXPORT_H

#include "ace/config-all.h"

#if defined (ACE_AS_STATIC_LIBS) && !defined (INSTALLATION_REPOSITORY_MANAGER_HAS_DLL)
#  define INSTALLATION_REPOSITORY_MANAGER_HAS_DLL 0
#endif /* ACE_AS_STATIC_LIBS && INSTALLATION_REPOSITORY_MANAGER_HAS_DLL */

#if !defined (INSTALLATION_REPOSITORY_MANAGER_HAS_DLL)
#  define INSTALLATION_REPOSITORY_MANAGER_HAS_DLL 1
#endif /* ! INSTALLATION_REPOSITORY_MANAGER_HAS_DLL */

#if defined (INSTALLATION_REPOSITORY_MANAGER_HAS_DLL) && (INSTALLATION_REPOSITORY_MANAGER_HAS_DLL == 1)
#  if defined (INSTALLATION_REPOSITORY_MANAGER_BUILD_DLL)
#    define Installation_Repository_Manager_Export ACE_Proper_Export_Flag
#    define INSTALLATION_REPOSITORY_MANAGER_SINGLETON_DECLARATION(T) ACE_EXPORT_SINGLETON_DECLARATION (T)
#    define INSTALLATION_REPOSITORY_MANAGER_SINGLETON_DECLARE(SINGLETON_TYPE, CLASS, LOCK) ACE_EXPORT_SINGLETON_DECLARE(SINGLETON_TYPE, CLASS, LOCK)
#  else /* INSTALLATION_REPOSITORY_MANAGER_BUILD_DLL */
#    define Installation_Repository_Manager_Export ACE_Proper_Import_Flag
#    define INSTALLATION_REPOSITORY_MANAGER_SINGLETON_DECLARATION(T) ACE_IMPORT_SINGLETON_DECLARATION (T)
#    define INSTALLATION_REPOSITORY_MANAGER_SINGLETON_DECLARE(SINGLETON_TYPE, CLASS, LOCK) ACE_IMPORT_SINGLETON_DECLARE(SINGLETON_TYPE, CLASS, LOCK)
#  endif /* INSTALLATION_REPOSITORY_MANAGER_BUILD_DLL */
#else /* INSTALLATION_REPOSITORY_MANAGER_HAS_DLL == 1 */
#  define Installation_Repository_Manager_Export
#  define INSTALLATION_REPOSITORY_MANAGER_SINGLETON_DECLARATION(T)
#  define INSTALLATION_REPOSITORY_MANAGER_SINGLETON_DECLARE(SINGLETON_TYPE, CLASS, LOCK)
#endif /* INSTALLATION_REPOSITORY_MANAGER_HAS_DLL == 1 */

// Set INSTALLATION_REPOSITORY_MANAGER_NTRACE = 0 to turn on library specific tracing even if
// tracing is turned off for ACE.
#if !defined (INSTALLATION_REPOSITORY_MANAGER_NTRACE)
#  if (ACE_NTRACE == 1)
#    define INSTALLATION_REPOSITORY_MANAGER_NTRACE 1
#  else /* (ACE_NTRACE == 1) */
#    define INSTALLATION_REPOSITORY_MANAGER_NTRACE 0
#  endif /* (ACE_NTRACE == 1) */
#endif /* !INSTALLATION_REPOSITORY_MANAGER_NTRACE */

#if (INSTALLATION_REPOSITORY_MANAGER_NTRACE == 1)
#  define INSTALLATION_REPOSITORY_MANAGER_TRACE(X)
#else /* (INSTALLATION_REPOSITORY_MANAGER_NTRACE == 1) */
#  if !defined (ACE_HAS_TRACE)
#    define ACE_HAS_TRACE
#  endif /* ACE_HAS_TRACE */
#  define INSTALLATION_REPOSITORY_MANAGER_TRACE(X) ACE_TRACE_IMPL(X)
#  include "ace/Trace.h"
#endif /* (INSTALLATION_REPOSITORY_MANAGER_NTRACE == 1) */

#endif /* INSTALLATION_REPOSITORY_MANAGER_EXPORT_H */

// End of auto generated file.
