// -*- C++ -*-
// $Id: Quoter_Producer_exec.h 93359 2011-02-11 11:33:12Z mcorino $

/**
 * Code generated by the The ACE ORB (TAO) IDL Compiler v2.0.0
 * TAO and the TAO IDL Compiler have been developed by:
 *       Center for Distributed Object Computing
 *       Washington University
 *       St. Louis, MO
 *       USA
 *       http://www.cs.wustl.edu/~schmidt/doc-center.html
 * and
 *       Distributed Object Computing Laboratory
 *       University of California at Irvine
 *       Irvine, CA
 *       USA
 * and
 *       Institute for Software Integrated Systems
 *       Vanderbilt University
 *       Nashville, TN
 *       USA
 *       http://www.isis.vanderbilt.edu/
 *
 * Information about TAO is available at:
 *     http://www.cs.wustl.edu/~schmidt/TAO.html
 **/
#ifndef CIAO_QUOTER_PRODUCER_EXEC_FI8FAR_H_
#define CIAO_QUOTER_PRODUCER_EXEC_FI8FAR_H_

#include /**/ "ace/pre.h"

#include "Quoter_ProducerEC.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#include /**/ "Quoter_Producer_exec_export.h"
#include "tao/LocalObject.h"

namespace CIAO_Quoter_Producer_Impl
{

  /**
   * Provider Executor Implementation Class: my_quoter_exec_i
   */

  class my_quoter_exec_i
    : public virtual ::Quoter::CCM_StockManager,
      public virtual ::CORBA::LocalObject
  {
  public:
    my_quoter_exec_i (
      ::Quoter::CCM_Producer_Context_ptr ctx);
    virtual ~my_quoter_exec_i (void);

    /** @name Operations and attributes from Quoter::StockManager */
    //@{

    virtual
    char * stock_exchange_name (void);

    virtual
    void stock_exchange_name (const char * stock_exchange_name);

    virtual
    ::CORBA::Boolean add_stock (const char * symbol,
    ::CORBA::Double quote);

    virtual
    void edit_stock (const char * symbol,
    ::CORBA::Double new_quote);

    virtual
    void remove_stock (const char * symbol,
    ::CORBA::Double_out quote);

    virtual
    ::CORBA::Boolean find_closest_symbol (char *& symbol);

    virtual
    ::CORBA::Double get_quote (const char * symbol);
    //@}

  private:
    ::Quoter::CCM_Producer_Context_var ciao_context_;
  };

  /**
   * Component Executor Implementation Class: Producer_exec_i
   */

  class Producer_exec_i
    : public virtual Producer_Exec,
      public virtual ::CORBA::LocalObject
  {
  public:
    Producer_exec_i (void);
    virtual ~Producer_exec_i (void);

    /** @name Supported operations and attributes. */
    //@{

    //@}

    /** @name Component attributes and port operations. */
    //@{

    virtual ::Quoter::CCM_StockManager_ptr
    get_my_quoter (void);
    //@}

    /** @name Operations from Components::SessionComponent. */
    //@{
    virtual void set_session_context (::Components::SessionContext_ptr ctx);
    virtual void configuration_complete (void);
    virtual void ccm_activate (void);
    virtual void ccm_passivate (void);
    virtual void ccm_remove (void);
    //@}

    /** @name User defined public operations. */
    //@{

    //@}

  private:
    ::Quoter::CCM_Producer_Context_var ciao_context_;

    /** @name Component attributes. */
    //@{
    ::Quoter::CCM_StockManager_var ciao_my_quoter_;
    //@}

    /** @name User defined members. */
    //@{

    //@}

    /** @name User defined private operations. */
    //@{

    //@}
  };

  extern "C" QUOTER_PRODUCER_EXEC_Export ::Components::EnterpriseComponent_ptr
  create_Quoter_Producer_Impl (void);
}

#include /**/ "ace/post.h"

#endif /* ifndef */
