// -*- C++ -*-
// $Id: ThreeComp_Master_exec.h 92902 2010-12-17 15:09:42Z mcorino $

/**
 * Code generated by the The ACE ORB (TAO) IDL Compiler v1.8.3
 * TAO and the TAO IDL Compiler have been developed by:
 *       Center for Distributed Object Computing
 *       Washington University
 *       St. Louis, MO
 *       USA
 *       http://www.cs.wustl.edu/~schmidt/doc-center.html
 * and
 *       Distributed Object Computing Laboratory
 *       University of California at Irvine
 *       Irvine, CA
 *       USA
 * and
 *       Institute for Software Integrated Systems
 *       Vanderbilt University
 *       Nashville, TN
 *       USA
 *       http://www.isis.vanderbilt.edu/
 *
 * Information about TAO is available at:
 *     http://www.cs.wustl.edu/~schmidt/TAO.html
 **/
#ifndef CIAO_THREECOMP_MASTER_EXEC_0MCF2C_H_
#define CIAO_THREECOMP_MASTER_EXEC_0MCF2C_H_

#include /**/ "ace/pre.h"

#include "ThreeComp_MasterEC.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#include /**/ "ThreeComp_Master_exec_export.h"
#include "tao/LocalObject.h"
#include "ace/Task.h"

namespace CIAO_ThreeComp_Master_Impl
{
  typedef ACE_Atomic_Op <TAO_SYNCH_MUTEX, CORBA::UShort > Atomic_UShort;

  /// Worker thread for asynchronous invocations
   class asynch_state_generator : public virtual ACE_Task_Base
   {
   public:
     asynch_state_generator (::ThreeComp::CCM_Master_Context_ptr context,
                                Atomic_UShort  &nr_of_rec,
                                Atomic_UShort  &nr_of_sent);

     virtual int svc (void);

   private:
     ::ThreeComp::CCM_Master_Context_var context_;
     Atomic_UShort  &nr_of_rec_;
     Atomic_UShort  &nr_of_sent_;

   };

   /// Worker thread for synchronous invocations
   class synch_state_generator : public virtual ACE_Task_Base
   {
   public:
     synch_state_generator (::ThreeComp::CCM_Master_Context_ptr context);
     virtual int svc (void);

   private:
     ::ThreeComp::CCM_Master_Context_var context_;
   };
  /*
   * Component Executor Implementation Class: Master_exec_i
   */

  class Master_exec_i
    : public virtual Master_Exec,
      public virtual ::CORBA::LocalObject
  {
  public:
    Master_exec_i (void);
    virtual ~Master_exec_i (void);

    //@{
    /** Supported operations and attributes. */
    //@}

    //@{
    /** Component attributes and port operations. */
    //@}

    //@{
    /** Operations from Components::SessionComponent. */
    virtual void set_session_context (::Components::SessionContext_ptr ctx);
    virtual void configuration_complete (void);
    virtual void ccm_activate (void);
    virtual void ccm_passivate (void);
    virtual void ccm_remove (void);
    //@}

    //@{
    /** User defined public operations. */
    //@}

  private:
    ::ThreeComp::CCM_Master_Context_var ciao_context_;

    //@{
    /** Component attributes. */
    //@}

    //@{
    /** User defined members. */
    asynch_state_generator* asynch_state_gen;
    synch_state_generator* synch_state_gen;
    Atomic_UShort nr_of_rec_;
    Atomic_UShort nr_of_sent_;
    //@}

    //@{
    /** User defined private operations. */
    //@}
  };
  class AMI4CCM_StateReplyHandler_run_my_state_i
    : public ::ThreeComp::CCM_AMI4CCM_StateReplyHandler,
      public virtual ::CORBA::LocalObject
    {
    public:
      AMI4CCM_StateReplyHandler_run_my_state_i (
          Atomic_UShort  &nr_of_rec,
          Atomic_UShort  &nr_of_sent);
      virtual ~AMI4CCM_StateReplyHandler_run_my_state_i (void);

      virtual void
      bar (
        ::CORBA::Long ami_return_val,
        const char * answer);

      virtual void
      bar_excep (
        ::CCM_AMI::ExceptionHolder_ptr excep_holder);
    private:
      Atomic_UShort  &nr_of_rec_;
      Atomic_UShort  &nr_of_sent_;
    };

    extern "C" THREECOMP_MASTER_EXEC_Export ::Components::EnterpriseComponent_ptr
    create_ThreeComp_Master_Impl (void);
  }

#include /**/ "ace/post.h"

#endif /* ifndef */
