// -*- C++ -*-
// $Id: MultiTopic_Receiver_exec.h 93117 2011-01-20 12:11:28Z mcorino $

/**
 * Code generated by the The ACE ORB (TAO) IDL Compiler v1.8.2
 * TAO and the TAO IDL Compiler have been developed by:
 *       Center for Distributed Object Computing
 *       Washington University
 *       St. Louis, MO
 *       USA
 *       http://www.cs.wustl.edu/~schmidt/doc-center.html
 * and
 *       Distributed Object Computing Laboratory
 *       University of California at Irvine
 *       Irvine, CA
 *       USA
 * and
 *       Institute for Software Integrated Systems
 *       Vanderbilt University
 *       Nashville, TN
 *       USA
 *       http://www.isis.vanderbilt.edu/
 *
 * Information about TAO is available at:
 *     http://www.cs.wustl.edu/~schmidt/TAO.html
 **/
#ifndef CIAO_MULTITOPIC_RECEIVER_EXEC_BDTSSY_H_
#define CIAO_MULTITOPIC_RECEIVER_EXEC_BDTSSY_H_


#include "MultiTopic_ReceiverEC.h"

#include /**/ "Receiver_exec_export.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#include "tao/LocalObject.h"

namespace CIAO_Shapes_Receiver_Impl
{
  class Receiver_exec_i;
   /**
   * @class reader activity generator
   *
   * @brief an active object used by Receiver to perform a periodical read action
   *
   */
   class read_action_Generator
     : public ACE_Event_Handler
   {
   public:
     read_action_Generator (Receiver_exec_i &callback);

     ~read_action_Generator ();

     virtual int handle_timeout (const ACE_Time_Value &tv,
                                 const void *arg);

   private:
     Receiver_exec_i &pulse_callback_;

   };

  /**
   * Provider Executor Implementation Class: info_out_data_listener_exec_i
   */

  class RECEIVER_EXEC_Export info_out_data_listener_exec_i
    : public virtual ::Shapes::DDS_Typed::CCM_Listener,
      public virtual ::CORBA::LocalObject
  {
  public:
    info_out_data_listener_exec_i (
      ::Shapes::CCM_Receiver_Context_ptr ctx);
    virtual ~info_out_data_listener_exec_i (void);

    //@{
    /** Operations and attributes from Shapes::Listener. */

    virtual
    void on_one_data (const ::ShapeType & datum,
    const ::CCM_DDS::ReadInfo & info);

    virtual
    void on_many_data (const ::ShapeTypeSeq & data,
    const ::CCM_DDS::ReadInfoSeq & infos);
    //@}

  private:
    ::Shapes::CCM_Receiver_Context_var ciao_context_;
  };

  /**
   * Component Executor Implementation Class: Receiver_exec_i
   */

  class RECEIVER_EXEC_Export Receiver_exec_i
    : public virtual Receiver_Exec,
      public virtual ::CORBA::LocalObject
  {
  public:
    Receiver_exec_i (void);
    virtual ~Receiver_exec_i (void);

    //@{
    /** Supported operations and attributes. */

    //@}

    //@{
    /** Component attributes and port operations. */

    virtual ::Shapes::DDS_Typed::CCM_Listener_ptr
    get_info_out_sq_data_listener (void);

    virtual ::Shapes::DDS_Typed::CCM_Listener_ptr
    get_info_out_tr_data_listener (void);

    virtual ::Shapes::DDS_Typed::CCM_Listener_ptr
    get_info_out_cl_data_listener (void);


    virtual ::CCM_DDS::CCM_PortStatusListener_ptr
    get_info_out_sq_status (void);

    virtual ::CCM_DDS::CCM_PortStatusListener_ptr
    get_info_out_tr_status (void);

    virtual ::CCM_DDS::CCM_PortStatusListener_ptr
    get_info_out_cl_status (void);


    virtual ::CCM_DDS::CCM_PortStatusListener_ptr
    get_info_get_sq_status (void);

    virtual ::CCM_DDS::CCM_PortStatusListener_ptr
    get_info_get_tr_status (void);

    virtual ::CCM_DDS::CCM_PortStatusListener_ptr
    get_info_get_cl_status (void);


    virtual ::CORBA::ULong rate (void);

    virtual void rate (::CORBA::ULong rate);
    //@}

    //@{
    /** Operations from Components::SessionComponent. */
    virtual void set_session_context (::Components::SessionContext_ptr ctx);
    virtual void configuration_complete (void);
    virtual void ccm_activate (void);
    virtual void ccm_passivate (void);
    virtual void ccm_remove (void);
    //@}

    //@{
    /** User defined public operations. */
    virtual void get_one (void);
    virtual void start (void);
    virtual void stop (void);

    //@}

  private:
    ::Shapes::CCM_Receiver_Context_var ciao_context_;

    //@{
    /** Component attributes. */
    ::Shapes::DDS_Typed::CCM_Listener_var ciao_info_out_cl_data_listener_;

     read_action_Generator * ticker_;

    ::CORBA::ULong rate_;
    //@}

    //@{
    /** User defined members. */

    //@}

    //@{
    /** User defined private operations. */

    //@}

    /// Get the ACE_Reactor
    ACE_Reactor* reactor (void);
  };

  extern "C" RECEIVER_EXEC_Export ::Components::EnterpriseComponent_ptr
  create_Shape_Receiver_Impl (void);
}

#endif /* ifndef */
